/*------------------------------------------------------------------------------
Blink.C

Copyright 1999-2003 by MmVisual - M.Mller
Erstellung BlinkLED 29.12.2001
--------------------------------------------------------------------------------
Testprogramm "Blinkende LED"

LED ist an Port PA4 des Cypress- Chips angeschlossen. Es wird nur dieser eine
Port als Ausgang definiert. Das Programm kann in den Speicher des AN21xx geladen
und gestartet werden. Sofort muss die LED anfangen zu Blinken (ca. 3 Hz). 
------------------------------------------------------------------------------*/

#include <REGAN21.H>			/* Register des AN21xx	*/
#include <EZREGS.H>				/* Externe Register des AN21xx  */

#include <stdlib.h>

// Definitionen der Routinen

// Belegung des Speichers
xdata unsigned char T0LED;
xdata unsigned char LED_BLINK _at_ 0x0101;	// LED blinken lassen
xdata unsigned char LED_COUNT _at_ 0x0100;	// Blinkende LED - Zhler nach Timer

xdata unsigned char var0 _at_ 0x011A;
xdata unsigned char var1 _at_ 0x011B;
xdata unsigned char var2 _at_ 0x011C;
xdata unsigned char var3 _at_ 0x011D;
xdata unsigned char var4 _at_ 0x011E;
xdata unsigned char var5 _at_ 0x011F;
xdata unsigned char var6 _at_ 0x0120;
xdata unsigned char var7 _at_ 0x0121;
xdata unsigned char var8 _at_ 0x0122;



unsigned char xdata malloc_mempool[0x1050] _at_ 0x1000;

xdata unsigned char *p;

/*------------------------------------------------
The main C function.  Program execution starts
here after stack initialization.
------------------------------------------------*/
void main()
{	EA = 0;

	// Ohne die folgenden 5 Zeilen kann das USB-Board sich nicht am USB-Port melden,
	// wenn Sie aus der IIC- Datei ein EEPROM herstellen!!!
	EUSB = 1; // Enable Firmware- USB
	USBCS = 4;
	USBIRQ = 0x1E;
	IBNIRQ = IBNIEN = TOGCTL = 0;
	EPIO[0] = 0x0A; // Enable Firmware- USB Ende

	OUTA = 0x00;		// Register vorbelegen
	OEA = 0x30;			// LED-Out ausschalten
	T2CON = 3;		// Timer 2 aus
	TR0 = 0;		// Timer 0 aus
	T1M = 0;		// Clock div 12
	CT1 = 0;		// Timer- Betrieb ein
	TH1 = 0x07;		// H-Register laden
	TL1 = 0xC0;		// L-Register laden insgesamt: 0xF831
	TF1 = 1;		// Interrupt ein
	ET1 = 1;		// Timer 1 Interrupt ein 
	TR1 = 1;		// Timer 1 einschalten
	EA = 1;			// Interrupt ein	
	LED_COUNT = LED_BLINK = 1;	// Zhler zurcksetzen und Blinken einschalten
	PORTACFG = 0;
	PORTBCFG = 0;
	PORTCCFG = 0;
	

	var0=0x00;
	var1=0xFF;
	var2=0xFF;
	var3=0xFF;
	var4=0xFF;
	var5=0xFF;
	var6=0xFF;

	init_mempool (&malloc_mempool, sizeof(malloc_mempool));


	while (1)		// IO- Werte kopieren ...
	{

	if(!p) p = (unsigned char*) malloc(100);
	else  p = (unsigned char*) realloc(p,var0*10+2);

//	OUTC++;
	var0++;
	var1=p;
	var2= ((int) p) >> 8;
	var3=4;
	var4=5;
	var5=6;
	var6=sizeof(malloc_mempool);
	
	
	//free(p);
	}
}

//
// Timer fr ms- Zhler
static void T1_isr (void) interrupt 3 using 3
{	TL1 = 0xC0;		// L-Register laden insgesamt: 0xF831
	TH1 = 0x07;		// H-Register laden
	if (LED_BLINK)
	{
		if (LED_COUNT-- == 0)	// Zhler zurcksetzen
		{	LED_COUNT = 50;		// Schleifenzhler neu setzen
			OUTA ^= 0x10;		// LED umschalten
		}
	}
}

