// onewire.c
#include "onewireHEAD.h"
#include <REGAN21.H>			/* Register des AN21xx	*/
#include <EZRegsHEAD.H>			/* Externe Register des AN21xx  */


void OWWriteByte(unsigned char byte) small {
	unsigned char i, Bit, maske;

	Bit=0x00;
	for(i=0;i<8;i++){
		maske = 1<<i;
		Bit = byte & maske;
		Bit = Bit>>i;
		OWWriteBit(Bit);
	}
}


unsigned char OWReadByte() small {
	unsigned char i, byte;

	byte=0x00;
	for(i=0;i<8;i++) byte = byte | (OWReadBit()<<i);

	return byte;
}


void OWWriteBit(unsigned char Bit) small {
	unsigned char i;

	OUTC=0xFF;
	OEC = 0xFF;

	if (Bit==0){
		for(i=0;i<37;i++) OUTC=0x00;  // 37 Schleifendurchlufe = ca. 70 us
		OEC=0x00; // |
		OEC=0x00; // V
		OEC=0x00; // Recovery-Time (min. 1us)					  
	}

	if (Bit==1){
		OUTC=0x00; // |
		OUTC=0x00; // |
		OUTC=0x00; // |
		OUTC=0x00; // V
		OUTC=0x00; // ca. 3 us
		for(i=0;i<33;i++)OEC=0x00; // 33 Schleifendurchlufe = ca. 68 us
	}	 
}


unsigned char OWReadBit() small {
	unsigned char Bit, i;

	OUTC=0xFF;
	OEC=0xFF;

	OUTC=0x00; // |
	OUTC=0x00; // |
	OUTC=0x00; // |
	OUTC=0x00; // V
	OUTC=0x00; // ca. 3 us
	
	for(i=0;i<4;i++) OEC=0x00; // ca. 7,5 us warten

	if ((PINSC >> 7)==1) Bit = 1;
	else Bit = 0;

	for(i=0;i<27;i++) OEC=0x00;	// ReadBit() dauert ca. 64 us
	return Bit;

}


unsigned char OWReset() small {
	unsigned char i, j, device_present;

	OEC=0xFF;
	for(i=0;i<2;i++) for(j=0;j<135;j++) OUTC=0x00; // Reset: ca. 500 us

	OEC=0x00;
	for(i=0;i<37;i++) OEC=0x00;  // 37 Schleifendurchlufe = ca. 70 us warten (0,54 Durchlufe/usec)

	if (PINSC == 0) device_present = 1;
	else device_present = 0;

	for(i=0;i<222;i++) OUTC=0x00;  // 222 Schleifendurchlufe = den Rest der 480 us (=410 us) warten
	
	return device_present;
}